# ToyML: Machine Learning from Scratch


[![Python](https://img.shields.io/badge/Python-3.10,%203.11,%203.12,%203.13-blue)](https://devguide.python.org/versions/)
[![PyPI](https://badge.fury.io/py/toyml.svg)](https://pypi.org/project/toyml/)

![Codecov](https://codecov.io/gh/ai-glimpse/toyml/branch/master/graph/badge.svg)
[![Build Docs](https://github.com/ai-glimpse/toyml/actions/workflows/build_docs.yml/badge.svg)](https://github.com/ai-glimpse/toyml/actions/workflows/build_docs.yml)
[![Test](https://github.com/ai-glimpse/toyml/actions/workflows/test.yml/badge.svg)](https://github.com/ai-glimpse/toyml/actions/workflows/test.yml)

[//]: # (![GitHub License]&#40;https://img.shields.io/github/license/ai-glimpse/toyml&#41;)

[![Code style: black](https://img.shields.io/badge/code%20style-black-000000.svg)](https://github.com/psf/black)
[![Ruff](https://img.shields.io/endpoint?url=https://raw.githubusercontent.com/astral-sh/ruff/main/assets/badge/v2.json)](https://github.com/astral-sh/ruff)
[![Imports: isort](https://img.shields.io/badge/%20imports-isort-%231674b1?style=flat&labelColor=ef8336)](https://pycqa.github.io/isort/)
[![Checked with mypy](https://www.mypy-lang.org/static/mypy_badge.svg)](https://mypy-lang.org/)
[![pre-commit](https://img.shields.io/badge/pre--commit-enabled-brightgreen?logo=pre-commit)](https://github.com/pre-commit/pre-commit)

![Waka Time](https://wakatime.com/badge/user/b1a6ec36-190a-4135-b888-17ab5663e841/project/250b9a9d-dd00-432d-b69f-041d1611b5b6.svg)


There are machine learning algorithms implemented from scratch.
Let's learn machine learning with simple toy code.


## Installation
```bash
pip install toyml
```


## Links
- Documentation: [https://ai-glimpse.github.io/toyml/](https://ai-glimpse.github.io/toyml/)
- PyPi: [https://pypi.org/project/toyml/](https://pypi.org/project/toyml/)
- Changelog: [https://ai-glimpse.github.io/toyml/CHANGELOG/](https://ai-glimpse.github.io/toyml/CHANGELOG/)


## RoadMap

- [x] Clustering: DBSCAN, Hierarchical(Agnes&Diana), Kmeans
- [x] Classification: KNN
- [x] Ensemble: Boosting(AdaBoost)
- [ ] Classification: NaiveBayes, DecisionTree, SVM
- [ ] Association Analysis: Apriori
- [ ] Ensemble: GBDT
